#include "rawproxy.h"

HEV createEvent ( void )
{
        HEV  handle;

DosCreateEventSem ( NULL, &handle, 0L, FALSE );
return ( handle );
}


void closeEvent ( HEV sem )
{
DosCloseEventSem ( sem );
}

void resetEvent ( HEV sem )
{
        ULONG  stat = 0;

DosResetEventSem ( sem, &stat );
}

void pulseEvent ( HEV sem )
{
DosPostEventSem ( sem );
}

void waitEvent ( HEV sem )
{
DosWaitEventSem ( sem, SEM_INDEFINITE_WAIT );
}


BOOL checkEvent ( HEV sem )
{
return (!DosWaitEventSem(sem,SEM_IMMEDIATE_RETURN)?TRUE:FALSE);
}
