#include "rawproxy.h"


void  _System newRequest ( ULONG parm )
{
        int     res;
        Sockets tempsocks;
        Sockets *socks;
        ULONG   toProxyTID;
        Request *preq;

preq = (Request *)parm;
socks = &tempsocks;
socks->hev = createEvent();
resetEvent ( socks->hev );
socks->flagExit = createEvent();
resetEvent ( socks->flagExit );
socks->inpSocket = preq->socket;
if ( (socks->proxySocket=newConnection(preq)) >= 0 )
    {
    if ( DosCreateThread(&toProxyTID,toProxyThread,(ULONG)socks,0L,THREAD_STACK_SIZE) )
        {
        fprintf(stderr,"Thread %d : start thread error (at run toProxyThread).\n", preq->threadNumber );
        soclose ( socks->proxySocket );
        pulseEvent ( socks->flagExit );
        }
    else
        {
        socks->inpSize = 0;
        for ( resetEvent(socks->flagExit); 
               checkEvent(socks->flagExit) == FALSE &&
               checkEvent(linkSem) == FALSE; )
            {
            res = receiveBuffer ( socks, _FROM_PROXY );
            if ( res == _FLAG_NEEDSEND )
                {
                toClient ( socks->inpBuf, socks->inpSize );
                res = sendBuffer ( socks, _FROM_PROXY );
                if ( res != socks->inpSize )
                    {
                    if ( checkEvent(socks->flagExit) == FALSE )
                        {
                        fprintf ( stderr,"Thread %d : Problem (%d) at sending to client.\n", preq->threadNumber, ERRNO);
                        pulseEvent ( socks->flagExit );
                        }
                    } 
                else
                    {
                    socks->inpSize = 0;
                    }
                } 
            else
                {
                if ( res == _FLAG_NODATA )
                    {
                    fprintf(stderr,"Thread %d : Proxy close connection for %s.\n",
                                 preq->threadNumber,inet_ntoa(preq->client.sin_addr));
                    pulseEvent ( socks->flagExit );
                    }                 
                if ( (res == _FLAG_ERROR) && 
                                  (checkEvent(socks->flagExit) == FALSE) )
                    pulseEvent ( socks->flagExit );
                }
            } 
        }
    shutdown ( socks->proxySocket, 2 );
    soclose ( socks->proxySocket );
    }
closeConnection ( socks->inpSocket );

threadsNumber--;
free ( preq );

waitEvent ( socks->hev );       // waiting for toProxyThread
closeEvent ( socks->hev );
}
