#include "rawproxy.h"


int  receiveBuffer ( Sockets *socks, USHORT direction )
{			
       int   need;
       int   res;
       int   socketError;
       int   inpSocket;
       UCHAR *buf;
       int   *psize;


if ( direction == _FROM_PROXY )
    {
    inpSocket = socks->proxySocket;
    buf = socks->inpBuf;
    psize = &socks->inpSize;
    }
else
    {
    inpSocket = socks->inpSocket;
    buf = socks->outBuf;
    psize = &socks->outSize;
    }
*psize = 0;
res = _FLAG_NODATA;
need = sizeof(socks->outBuf);
if ( (res=recv(inpSocket,buf,need,0)) == 0 )
    {
    res = _FLAG_NODATA;
    }
else 
    {
    if ( res < 0 )
        {
        socketError = ERRNO;
        if ( socketError != S_EINTR )
            res = _FLAG_ERROR;
        else
            res = _FLAG_NODATA;
        }
    else
        {
        *psize = res;
        res = _FLAG_NEEDSEND;
        }
    }
return ( res );
}
