#include "rawproxy.h"



void _System serverThread ( ULONG isock )
{
        struct sockaddr_in client;
        int    res;
        int    slen;
        int    rc;
        ULONG  socknum;
        struct linger ling;
        ULONG  newRequestTID;
        Request *preq;

socknum = (ULONG)isock;
for ( ; ; )
    {
    if( checkEvent(linkSem) == TRUE )
        break;
    slen = sizeof(client);
    if ( (res=accept(mainSocket,(struct sockaddr *)&client,&slen)) >= 0 )
        {
        fprintf(stderr,"Server thread : New request from address %s.\n",inet_ntoa(client.sin_addr));
        ling.l_onoff = 0;
        ling.l_linger = 0;
        setsockopt ( res, SOL_SOCKET, SO_LINGER, (char *)&ling, sizeof(ling) );
        if ( (preq=malloc(sizeof(Request))) != NULL )
            {
            preq->socket = res;
            preq->threadNumber = ++threadsNumber;
            preq->client = client;
            if ( DosCreateThread((ULONG *)&preq->TID,newRequest,
                                 (ULONG)preq,0L,THREAD_STACK_SIZE) )
                {
                fprintf(stderr,"Server thread : start %d thread error"
                               " (at run newRequest thread).\n",preq->threadNumber);
                soclose ( res );             
                }
            }
        else
            {
            fprintf(stderr,"Not enough memory for request (total threads %d).\n",threadsNumber);
            }
        }
    } 
}
