#include "rawproxy.h"


void  _System toProxyThread ( ULONG idsocks )
{
        int     res;
        Sockets *socks;
        int volatile threadNumber;

socks = (Sockets *)idsocks;
threadNumber = ++threadsNumber;
socks->outSize = 0;

for ( ; checkEvent(socks->flagExit) == FALSE && checkEvent(linkSem) == FALSE; )
    {
    res = receiveBuffer ( socks, _TO_PROXY );
    if ( res == _FLAG_NEEDSEND )
        {
        toServer ( socks->outBuf, socks->outSize );
        res = sendBuffer ( socks, _TO_PROXY );
        if ( res != socks->outSize )
            {
            if ( checkEvent(socks->flagExit) == FALSE )
                {
                fprintf(stderr,"Thread %d : Problem (%d) at send to proxy.\n", threadNumber, ERRNO);
                pulseEvent(socks->flagExit);
                }
            } 
        else
            {
            socks->outSize = 0;
            }
        }
    else
        {
        if ( res == _FLAG_NODATA )
            {
            pulseEvent(socks->flagExit);
            }
        if ( res == -1 && checkEvent(socks->flagExit) == FALSE )
            pulseEvent(socks->flagExit);
        }
    } 
shutdown ( socks->inpSocket, 2 );
soclose ( socks->inpSocket );
shutdown ( socks->proxySocket, 2 );
soclose ( socks->proxySocket );
threadsNumber--;
pulseEvent ( socks->hev );
}
